/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 17/01/2018
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapRuanganLoginToRuanganP;
import com.portofolio.entity.vo.MapRuanganLoginToRuanganPId;

@Lazy
@Repository
public interface MapRuanganLoginToRuanganPDao extends CrudRepository<MapRuanganLoginToRuanganP, MapRuanganLoginToRuanganPId> {

	

	@Modifying
	@Query("update MapRuanganLoginToRuanganP m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdRuanganLogin =:kdRuanganLogin and m.id.enumJenisMaping=:enumJenisMaping and m.id.enumKelompokTransaksi=:enumKelompokTransaksi")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile, @Param("kdRuanganLogin") String kdRuanganLogin, @Param("enumJenisMaping")Integer enumJenisMaping, @Param("enumKelompokTransaksi")Integer enumKelompokTransaksi);
	
	String QListAll = "select new map(model.id as kode "
			+ ", id.kdRuanganPelayanan as kdRuanganPelayanan, ruanganPelayanan.namaRuangan as namaRuanganPelayanan "
			+ ", id.kdRuanganLogin as kdRuanganLogin, ruanganLogin.namaRuangan as namaRuanganLogin "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec " + ", model.version as version )"
			+ " from MapRuanganLoginToRuanganP model " + " left join model.id id " + " left join model.ruanganLogin ruanganLogin "
			+ " left join model.ruanganPelayanan ruanganPelayanan " + " where model.id.kdProfile =:kdProfile and model.statusEnabled =true ";

	//return Objek
	@Query("select model from MapRuanganLoginToRuanganP model where model.id.kdProfile=:kdProfile and model.id.kdRuanganLogin=:kdRuanganLogin and model.id.enumJenisMaping=:enumJenisMaping and model.id.enumKelompokTransaksi=:enumKelompokTransaksi ")
	List<MapRuanganLoginToRuanganP> findObjekRuanganLoginToRuanganPelayananByPrimary( @Param("kdProfile")Integer kdProfile,
			 @Param("kdRuanganLogin")String kdRuanganLogin,  @Param("enumJenisMaping")Integer enumJenisMaping,@Param("enumKelompokTransaksi") Integer enumKelompokTransaksi);

	//return Map
	@Query(QListAll+" and  model.id.kdProfile=:kdProfile and model.id.kdRuanganLogin=:kdRuanganLogin and model.id.enumJenisMaping=:enumJenisMaping and model.id.enumKelompokTransaksi=:enumKelompokTransaksi ")
	List<Map<String,Object>> findMapRuanganLoginToRuanganPelayananByPrimary( @Param("kdProfile")Integer kdProfile,
			 @Param("kdRuanganLogin")String kdRuanganLogin,  @Param("enumJenisMaping")Integer enumJenisMaping,@Param("enumKelompokTransaksi") Integer enumKelompokTransaksi);

	//return Map
	@Query(QListAll+" and  model.id.kdProfile=:kdProfile and model.id.kdRuanganLogin=:kdRuanganLogin and model.id.enumJenisMaping=:enumJenisMaping and model.id.enumKelompokTransaksi=:enumKelompokTransaksi and ruanganPelayanan.namaRuangan like '%:namaRuanganPelayanan%' ")
	List<Map<String, Object>> findMapRuanganLoginToRuanganPelayananByPrimary( @Param("kdProfile")Integer kdProfile,
			 @Param("kdRuanganLogin")String kdRuanganLogin,  @Param("enumJenisMaping")Integer enumJenisMaping,@Param("enumKelompokTransaksi") Integer enumKelompokTransaksi,@Param("namaRuanganPelayanan") String namaRuanganPelayanan);


	//return String
	@Query("select id.kdRuanganPelayanan from MapRuanganLoginToRuanganP model left join model.id id  left join model.ruanganLogin ruanganLogin  left join model.ruanganPelayanan ruanganPelayanan  where model.id.kdProfile =:kdProfile and model.statusEnabled =true and  model.id.kdProfile=:kdProfile and model.id.kdRuanganLogin=:kdRuanganLogin and model.id.enumJenisMaping=:enumJenisMaping and model.id.enumKelompokTransaksi=:enumKelompokTransaksi ")
	List<String> findKdRuanganPelayananByPrimary( @Param("kdProfile")Integer kdProfile,
			 @Param("kdRuanganLogin")String kdRuanganLogin,  @Param("enumJenisMaping")Integer enumJenisMaping,@Param("enumKelompokTransaksi") Integer enumKelompokTransaksi);

}
